package net.krakatoa.proxy.listener;

import earth.krakatao.events.KraSocketClientEventInterface;
import earth.krakatao.protocol.KraSocketClientProtocolMessage;
import net.krakatoa.proxy.ProxySystem;
import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import org.java_websocket.handshake.ServerHandshake;

public class SocketClientMessageListener implements KraSocketClientEventInterface {

  @Override
  public void onOpen(ServerHandshake serverHandshake) {
    for (ProxiedPlayer proxiedPlayer : ProxyServer.getInstance().getPlayers()) {
      proxiedPlayer.sendMessage(new TextComponent("§cSocket §8» §aConnected"));
    }
  }

  @Override
  public void onMessage(KraSocketClientProtocolMessage kraProtocolMessage) {

    System.out.println(
        "kraProtocolMessage " + kraProtocolMessage.getCmdID() + " " + kraProtocolMessage.getArgs());

    // remove cmdID from cmdID list
    ProxySystem.getInstance().getKraSocketClientProtocol().getCmdIDs()
        .removeIf(cmdID -> cmdID == kraProtocolMessage.getCmdID());

    System.out.println(
        "consumer ids " + ProxySystem.getInstance().getKraSocketClientProtocol()
            .getConsumerHashMap().keySet());

    // test - mobile or voice socket connected
    if (kraProtocolMessage.getCmdNumber() == 15) {
      ProxyServer.getInstance().getScheduler().runAsync(ProxySystem.getInstance(), () -> {
        System.out.println(ProxySystem.getInstance().getFormatter()
            .stringToUuid(kraProtocolMessage.getUuid()));

        ProxiedPlayer proxiedPlayer = ProxySystem.getInstance().getProxy()
            .getPlayer(ProxySystem.getInstance().getFormatter()
                .stringToUuid(kraProtocolMessage.getUuid()));

        if (proxiedPlayer != null) {
          if (kraProtocolMessage.getArgs().equals("1")) {
            proxiedPlayer.sendMessage(new TextComponent("§5Mobile §8» §cConnection lost!"));
          } else {
            proxiedPlayer.sendMessage(
                new TextComponent("§bVoice §8» §cConnection lost!"));
          }
        }
      });
    }

    ProxySystem.getInstance().getKraSocketClientProtocol().getConsumerHashMap()
        .forEach((cmdID, consumer) -> {
          if (cmdID == kraProtocolMessage.getCmdID()) {
            System.out.println("accept " + cmdID + " " + kraProtocolMessage.getCmdID());
            consumer.accept(kraProtocolMessage);
          }
        });
  }

  @Override
  public void onClose(int code, String reason, boolean remote) {
    for (ProxiedPlayer proxiedPlayer : ProxyServer.getInstance().getPlayers()) {
      proxiedPlayer.sendMessage(
          new TextComponent(
              "§cSocket §8» §c" + (remote ? "Connection! Closed by remote peer" : reason)));
    }
  }
}
